<?php
// This is for Poedit.
function mariginari_pcp_poo() {
	$mariginari_plugin_name=__('post changelog plugin', 'mariginari');
	$mariginari_plugin_description=__('Provides shortcodes to ease the writing of changelogs for posts and pages.', 'mariginari');
}

/*
*	Text Domain: mariginari
*    	Plugin URI: http://mummila.net/nuudelisoppa/mariginari-theme-for-wordpress/
* 	Author: Jani Uusitalo
* 	Author URI: http://mummila.net/
*	Plugin Name: post changelog plugin
*   	Description: Provides shortcodes to ease the writing of changelogs for posts and pages.
* 	Version: 9000
*
* 
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program; if not, write to the Free Software
*	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/



// Generate style sheet and script.
if ($_GET['mariginaristyle'] == 'pcp') {
	header("Content-type: text/css");
	include("../../../wp-load.php");
	return mariginari_get_pcp_style();
}
else if ($_GET['mariginariscript'] == 'pcp') {
	header('Content-type: application/javascript');
	include("../../../wp-load.php");
	return mariginari_get_pcp_script();
}

// Hook up generated style sheet and script.
if (function_exists('add_action')) {
	add_action('wp_print_scripts', 'mariginari_pcp_script');
	add_action('wp_print_styles', 'mariginari_pcp_style');
}
function mariginari_pcp_script() {
	wp_enqueue_script('mariginari-post-changelog-script', WP_PLUGIN_URL.'/'.plugin_basename(__FILE__).'?mariginariscript=pcp',array(), '9000');
}
function mariginari_pcp_style() {
	wp_enqueue_style('mariginari-post-changelog-style', WP_PLUGIN_URL.'/'.plugin_basename(__FILE__).'?mariginaristyle=pcp',array(), '9000', 'all');
}

// The actual shortcodes' translation.
if (function_exists('add_filter')) {
	// Do changelog after footnotes.
	add_filter('the_content', 'mariginari_post_changelog', 9);
}
function mariginari_post_changelog($content = null) {
	global $shortcode_tags;
	$old_shortcodes = $shortcode_tags;
	$shortcode_tags = array();

	add_shortcode(__('changelog', 'mariginari'), 'mariginari_translate_changelog');
	add_shortcode(__('edit', 'mariginari'), 'mariginari_translate_edit');
	add_shortcode(__('at', 'mariginari'), 'mariginari_translate_at');

	$content = do_shortcode($content);

	$shortcode_tags = $old_shortcodes;

	return $content;
}
function mariginari_translate_changelog($atts = null, $content = null) {
	global $post;
	return '<p class="mariginari-post-changelog"><a class="mariginari-post-changelog" id="mariginari-post-changelog-'.$post->ID.'" href="'.get_permalink($post->ID).'#mariginari-post-changelog-'.$post->ID.'" onclick="javascript:void(mariginariPCPToggleDisplay('."'".$post->ID."'".')); return false;" onmouseout="window.status='."'';".'" onmouseover='."'window.status=".'"'.mariginari_get_pcp_option('mouseover status text').'"; return true;\'></a></p> <ol class="mariginari-post-changelog" id="mariginari-post-changelog-entries-'.$post->ID.'">'.do_shortcode($content).'</ol>';
}
function mariginari_translate_edit($atts = null, $content = null) {
	return '<li>'.do_shortcode($content).'</li>';
}
function mariginari_translate_at($atts = null, $content = null) {
	return '<span class="mariginari-post-changelog-edit">'.do_shortcode($content).'</span>';
}

// Settings are centralized here to ease changes.
function mariginari_load_pcp_options() {
	$options['toggler text'] = ' ' . __('Changelog', 'mariginari');
	$options['changelog title'] = __('Changelog:', 'mariginari');
	$options['mouseover status text'] = __('Show/hide Changelog', 'mariginari');
	return $options;
}

// Get individual options.
function mariginari_get_pcp_option($option_name) {
	$options = mariginari_load_pcp_options();
	return $options[$option_name];
}

// Generate the style sheet and script.
function mariginari_get_pcp_style() {
?>
p.mariginari-post-changelog {
	margin-top:3em;
	text-indent:0;
	font-size: .8em;
}

* a.mariginari-post-changelog,
* a.mariginari-post-changelog:link,
* a.mariginari-post-changelog:hover,
* a.mariginari-post-changelog:visited,
* a.mariginari-post-changelog:active,
* a.mariginari-post-changelog:focus {
	cursor:pointer;
	text-decoration:none;
	background-color:inherit !important;
	border-style:none;
	outline: none;
	-moz-outline-style: none;
	color:#A20163 !important;
}

a.mariginari-post-changelog:after {
	content:"<?php echo mariginari_get_pcp_option('changelog title'); ?>"
}

ol.mariginari-post-changelog {
		margin: 0;
		margin-bottom: 3em;
		padding: 0;
		font-size: .8em
}

ol.mariginari-post-changelog>li {
	list-style-type: none;
	margin-top:1.5em;
	text-indent:0
}

ol.mariginari-post-changelog>li:first-child {
	margin-top:0
}

.mariginari-post-changelog span.edit {
	font-weight:bold
}
	<?php
}

function mariginari_get_pcp_script() {
?>
var mariginariPCPStyleSheet = false;
mariginariPCPInit();
function mariginariPCPGetStyleSheet() {
  var i;
  for (i = 0; i < document.styleSheets.length; i++) {
    if (document.styleSheets[i].ownerNode.id == 'mariginari-post-changelog-style-css') {
      mariginariPCPStyleSheet = document.styleSheets[i];
      break;
    }
  }
  return mariginariPCPStyleSheet;
}

function mariginariPCPGetRuleIdBySelector(wantedSelectorText) {
  var j;
  for (j = 0; j < mariginariPCPStyleSheet.cssRules.length; j++) {
    if (mariginariPCPStyleSheet.cssRules[j].selectorText == wantedSelectorText) {
      break;
    }
  }
  if (j < mariginariPCPStyleSheet.cssRules.length) {
    return j;
  }
  else {
    return -1;
  }
}

function mariginariPCPSetHidden(togglerId) {
  var togglerRuleId = mariginariPCPGetRuleIdBySelector("a#" + togglerId + ":after");
  if (togglerRuleId >= 0) {
    mariginariPCPStyleSheet.deleteRule(togglerRuleId);
  }
  mariginariPCPStyleSheet.insertRule("a#" + togglerId + ":after { content:'<?php echo '⊞'.mariginari_get_pcp_option('toggler text'); ?>' }", 0);
  return true;
}
function mariginariPCPSetShown(togglerId) {
  var togglerRuleId = mariginariPCPGetRuleIdBySelector("a#" + togglerId + ":after");
  if (togglerRuleId >= 0) {
    mariginariPCPStyleSheet.deleteRule(togglerRuleId);
  }
  mariginariPCPStyleSheet.insertRule("a#" + togglerId + ":after { content:'<?php echo '⊟'.mariginari_get_pcp_option('toggler text'); ?>' }", 0);
  return true;
}
function mariginariPCPToggleDisplay (postId) {
  var entries = document.getElementById('mariginari-post-changelog-entries-' + postId);
  var togglerId = 'mariginari-post-changelog-' + postId;
  if ( entries.style.display == 'block' ) {
    entries.style.display='none';
    mariginariPCPSetHidden(togglerId);
  }

  else {
    entries.style.display='block';
    mariginariPCPSetShown(togglerId);
  }

  return true;
}

function mariginariPCPInit() {
  var init = true;
  mariginariPCPStyleSheet = mariginariPCPGetStyleSheet();
  if (mariginariPCPStyleSheet == false) {
    return false;
  }
  mariginariPCPStyleSheet.insertRule('@media screen { ol.mariginari-post-changelog { display: none } }', 1);
  var oldTogglerRuleId = mariginariPCPGetRuleIdBySelector('a.mariginari-post-changelog:after');
  if (oldTogglerRuleId < 0) {
    init = false;
  }
  else {
    mariginariPCPStyleSheet.deleteRule(oldTogglerRuleId);
  }
  mariginariPCPStyleSheet.insertRule("@media print { a.mariginari-post-changelog:after { content:'<?php echo mariginari_get_pcp_option('changelog title'); ?>' } }", 0);	
  mariginariPCPStyleSheet.insertRule("@media screen { ol.mariginari-post-changelog { display: none; } }", 0);
  mariginariPCPStyleSheet.insertRule("@media screen { a.mariginari-post-changelog:after { content:'<?php echo '⊞'.mariginari_get_pcp_option('toggler text'); ?>' } }", 0);
  return init;
}
<?php
}

?>
